{$R-}
Unit BufCvt;

Interface

Const MoonXor    = $5D;
      Remplace   = $7F;
Type  BufferTyp  = Array[1..64000] of Byte;
      BufPtr     = ^BufferTyp;

Procedure Cvt6To8(pts,ptd:BufPtr; SizeS:Word);
Function Cvt8To6(pts,ptd:BufPtr; SizeS:Word):Word; (*renvoie taille*)

Procedure Cvt8To7(pts,ptd:BufPtr; Size:Word);
Procedure Cvt8To7_2(pts,ptd:BufPtr; Size:Word);
Procedure Cvt7To8(pts,ptd:BufPtr; Size:Word);
Function  SupCvt7To8(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word;
Function  SupCvt8To7(pts,ptd:BufPtr; Size:Word; MaxSize:Word;
                    Recode0d:Boolean; ToXor:Byte):Word;
Function  SupCvt8To8c(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word; {enCodage}
Function  SupCvt8To8d(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word; {Dcodage}

Implementation

Const Excluded     = [0,5,7,19,27];


Procedure Cvt6To8(pts,ptd:BufPtr; SizeS:Word);
Var b,Dernier:Byte;
    i,Taille:Word;

Procedure Ajoute(b:Byte);
Begin
     Inc(Taille); ptd^[Taille]:=b;
End;

Begin
     While SizeS mod 4<>0 do Begin Inc(SizeS); pts^[SizeS]:=0; End;
     i:=0; Taille:=0;
     Repeat
           Inc(i); b:=pts^[i];
           Case (i-1) mod 4 of
                0: Begin
                        Dernier:=(b and $1F) or ((b and $40) shr 1);
                   End;
                1: Begin
                        Dernier:=Dernier or ((b and 1) shl 6) or ((b and 2) shl 6);
                        Ajoute(Dernier);
                        Dernier:=((b and $1C) shr 2) or ((b and $40) shr 3);
                   End;
                2: Begin
                        Dernier:=Dernier or ((b and $F) shl 4);
                        Ajoute(Dernier);
                        Dernier:=((b and $10) shr 4) or ((b and $40) shr 5);
                   End;
                3: Begin
                        Dernier:=Dernier or ((b and $1F) shl 2) or ((b and $40) shl 1);
                        Ajoute(Dernier);
                   End;
           End;
     Until i=SizeS;
End;


Function Cvt8To6(pts,ptd:BufPtr; SizeS:Word):Word;
{ La taille renvoye peut tre recalcule en partant de SizeS :
  Taille:=4*(SizeS div 3) + SizeS mod 3 (+1 si (SizeS mod 3<>0))  }
Var i,Taille:Word;
    b,Reste:Byte;
    Fini:Boolean;

Procedure Ajoute(b:Byte);
Begin
     Inc(Taille); ptd^[Taille]:=b;
End;

Begin
     i:=0; Taille:=0;
     Repeat
           Inc(i); b:=ptS^[i]; Fini:=False;
           Case (i-1) mod 3 of
                0: Begin
                        Ajoute((b and $1F) or ((b and $20) shl 1));
                        Reste:=b shr 6;
                   End;
                1: Begin
                        Ajoute(Reste or ((b and $7) shl 2) or ((b and $8) shl 3));
                        Reste:=((b and $F0) shr 4);
                   End;
                2: Begin
                        Ajoute(Reste or ((b and 1) shl 4) or ((b and 2) shl 5));
                        Reste:=b shr 2;
                        Ajoute((Reste and $1F) or ((Reste and $20) shl 1));
                        Reste:=0; Fini:=True;
                   End;
           End;
     Until i=SizeS;
     if not Fini then Ajoute(Reste);
     For i:=1 to Taille do ptD^[i]:=(ptD^[i] and $7F) or $20;
     Cvt8To6:=Taille;
End;


{$Define RPlus} {$IfOpt R-} {$Undef RPlus} {$Endif}
{$R-}
Function Rol(b,Nb:Byte):Byte;
{ effectue une rotation vers la gauche au sens assembleur du terme : les bits
  qui "sortent"  gauche "rentrent" par la droite }
Var x,i:Byte;
Begin
     For i:=1 to Nb do
     Begin
          x:=b shl 1; if b and $80<>0 then x:=x or 1; b:=x;
     End;
     Rol:=b;
End;


Function Rol2(b,Nb:Byte):Byte; Assembler;
{ version rapide de la fonction prcdente }
Asm
     Mov AL,b
     Mov Cl,Nb
     Rol Al,CL
End;


Procedure Cvt8To7(pts,ptd:BufPtr; Size:Word);
Var Mask,i,j:Word;
    a,c,Retenue:Byte;
Begin
     Mask:=$7F; i:=0; j:=0; Retenue:=0;
     Repeat
           Inc(i); c:=pts^[i]; Inc(j); a:=c;
           c:=Rol2(Retenue,(i-1) mod 7) or ((c and Mask) shl ((i-1) mod 7));
           Retenue:=a and (not Mask);
           ptd^[j]:=c;
           Mask:=Mask shr 1;
           if Mask=0 then
           Begin
                Inc(j); ptd^[j]:=Retenue shr 1; Retenue:=0; Mask:=$7F;
           End;
     Until i>=Size;
     if Mask<>$7F then
     Begin
          Inc(j); ptd^[j]:=Rol(Retenue,(i-1) mod 7+1);
     End;
End;


Procedure Cvt8To7_2(pts,ptd:BufPtr; Size:Word); Assembler;
{ Version rapide de la procdure prcdente }
Var i,j:Byte;
Asm
     Push DS
     Cld
     Mov CX,Size
     LDS SI,pts
     LES DI,ptd
     Mov BL,$7F    {BL = Mask}
     Xor BH,BH     {BH = Retenue}
     Mov Dl,0      {DL = i-1 mod 7}

@Bcl:
     LodsB
     Mov AH,AL
     And AL,BL
     XChg CL,DL   {DL:=CL CL:=DL}
     Shl  Al,Cl
     Rol  BH,CL
     Or   AL,BH
     XChg Cl,DL   {on remet CL et DL}
     Not BL; And AH,BL; Not BL;
     Mov BH,AH
     StosB
     Shr BL,1     {Mask:=Mask shr 1}
     And BL,BL    {Bl=0 ?}
     Jne @Suite   {non, aller  @Suite}
     Shr BH,1
     Mov AL,BH
     StosB
     Xor BH,BH
     Mov BL,$7F
@Suite:
     Cmp CX,1
     Je  @EndBcl
     {fin de la boucle}
     Inc DL
     Cmp DL,7
     Jne @DoBcl
     Xor Dl,DL
@DoBcl:
     Loop @Bcl
@EndBcl:
     Cmp  BL,$7F
     Je @Bye
     Mov Cl,DL
     Inc CL
     Rol BH,CL
     Mov AL,BH
     StosB
@Bye:
     Pop DS
End;


Procedure Cvt7To8(pts,ptd:BufPtr; Size:Word);
Var i,j:Word;
    a,c,OnGarde:Byte;
Begin
     i:=0; j:=0; OnGarde:=0;
     Repeat
           Inc(i); c:=pts^[i]; a:=(i-1) mod 8;
           if a<>0 then
           Begin
                Inc(j); Ptd^[j]:=OnGarde or (c shl (8-a));
           End;
           OnGarde:=(c and $7F) shr a;
     Until i>=Size;
End;
{$IfDef RPlus} {$R+} {$Undef RPlus} {$Endif}


Function SupCvt8To7(pts,ptd:BufPtr; Size:Word; MaxSize:Word;
                    Recode0d:Boolean; ToXor:Byte):Word;
Var p:BufPtr;
    h,j,w:Word;
    b:Byte;
Begin
     GetMem(p,(Size+1)*8 div 7);
     Cvt8To7_2(pts,p,Size); w:=(8*Size+6) div 7;
     {      ^utilisation de la procdure rapide }
     h:=0;
     For j:=1 to w do
     Begin
          b:=p^[j] xor ToXor;
          if (b in Excluded) or (b=Remplace) then
          Begin
               Inc(h); ptd^[h]:=Remplace;
               Inc(h);
               Case b of
{Nul}               0 : ptd^[h]:=Byte('A');
{^E}                5 : ptd^[h]:=Byte('E');
{Bip}               7 : ptd^[h]:=Byte('G');
{^S}               19 : ptd^[h]:=Byte('S');
{Esc}              27 : ptd^[h]:=Byte('#');
{remplace}         else ptd^[h]:=Byte('R');
               End;
          End else
          if (b=$0d) and Recode0d then
          Begin
               Inc(h); ptd^[h]:=Remplace; Inc(h); Ptd^[h]:=Byte('M');
          End else
          Begin
               if h<MaxSize then
               Begin
                    Inc(h); ptd^[h]:=b;
               End;
          End;
     End;
     FreeMem(p,(Size+1)*8 div 7);
     SupCvt8To7:=h;
End;


Function SupCvt7To8(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word;
Var p:BufPtr;
    h,j:Word;
Begin
     GetMem(p,Size);
     h:=0; j:=0;
     Repeat
           Inc(j);
           if pts^[j]=Remplace then
           Begin
                Inc(j);
                Case pts^[j] of
{A=Nul}              $41: Begin Inc(h); p^[h]:=0;  End;
{E=^E}               $45: Begin Inc(h); p^[h]:=5;  End;
{G=Bip}              $47: Begin Inc(h); p^[h]:=7;  End;
{S=^S}               $53: Begin Inc(h); p^[h]:=19; End;
{#=Esc}              $23: Begin Inc(h); p^[h]:=27; End;
{R=remplace}         $52: Begin Inc(h); p^[h]:=Remplace; End;
{M=^M}               $4D: Begin Inc(h); p^[h]:=$0d; End;
                End;
           End else Begin Inc(h); p^[h]:=pts^[j]; End;
     Until j>=Size;
     For j:=1 to h do p^[j]:=p^[j] xor ToXor;
     Cvt7To8(p,ptd,h);
     FreeMem(p,Size);
     SupCvt7To8:=(h*7) div 8;
End;


Function  SupCvt8To8c(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word; {enCodage}
Var j,t:Word;
    b:Byte;
Begin
     j:=0; t:=0;
     Repeat
           Inc(j);
           b:=pts^[j]; b:=b xor ToXor;
           Inc(t);
           Case b of
                $13      : Begin
                                ptd^[t]:=Remplace; Inc(t); b:=Ord('M');
                           End;
                $00      : Begin
                                ptd^[t]:=Remplace; Inc(t); b:=Ord('0');
                           End;
                Remplace : if (j<Size) and
                              (((pts^[j+1] xor ToXor)=Ord('R'))
                              or ((pts^[j+1] xor ToXor)=Ord('M'))
                              or ((pts^[j+1] xor ToXor)=Ord('0'))) then
                           Begin
                                ptd^[t]:=Remplace; Inc(t); b:=Ord('R');
                           End;
           End;
           ptd^[t]:=b;
     Until (j>=Size);
     SupCvt8To8c:=t;
End;


Function  SupCvt8To8d(pts,ptd:BufPtr; Size:Word; ToXor:Byte):Word; {Dcodage}
Var j,t:Word;
    b:Byte;
Begin
     j:=0; t:=0;
     Repeat
           Inc(j);
           b:=pts^[j];
           if b=Remplace then
              if j<Size then
                 if Pts^[j+1]=Ord('R') then Inc(j) else
                 if Pts^[j+1]=Ord('M') then Begin Inc(j); b:=$13; End else
                 if Pts^[j+1]=Ord('0') then Begin Inc(j); b:=$00; End;
           Inc(t); ptd^[t]:=b xor ToXor;
     Until j>=Size;
     SupCvt8To8d:=t;
End;


End.
