Unit Patcher;

Interface

Type PatcherActionTyp = (Lire,Ecrire);

Function Patch(FName,Id:String; Action:PatcherActionTyp; Var d; Len:Word):Byte;
{ Codes d'erreurs renvoys
  0: Ok, chane trouve
  1: Fichier non trouv
  2: Chane non trouve }

Implementation

Function Patch(FName,Id:String; Action:PatcherActionTyp; Var d; Len:Word):Byte;
Label Bye;
Const TBuf   = 8192;
      Limite =   92;
      Reste  = TBuf-Limite;
Type  DataT     = Array[1..64000] of Char;
      DataP     = ^DataT;
Var   p      : DataP;   {tampon de lecture}
      Size   : Word;    {nombre de car dans le tampon}
      Lu     : Word;    {nombre d'octets lus}
      Total  : LongInt; {adresse absolue de la chane pour seek}
      c      : Char;
      f      : File;
      i      : Word;    {pointeur dans le tampon}
      j      : Word;    {pointeur sur le dernier caractre envisag}
      Li     : LongInt;
Begin
     Assign(f,FName); {$i-} Reset(f,1); {$i+}
     if IoResult<>0 then Begin Patch:=1; Exit; End;
     GetMem(p,TBuf);
     BlockRead(f,p^,TBuf,Size);
     if Size>0 then
     Begin
          i:=0; c:=Id[1]; Total:=0;
          Repeat
                Inc(i);
                if (i>Reste) and (Size=TBuf) then
                Begin
                     Move(p^[Reste+1],p^[1],Limite); Dec(i,Reste); Dec(Size,Reste);
                     BlockRead(f,p^[Size+1],Reste,Lu); Inc(Size,Lu);
                     Inc(Total,Reste);
                End;
                if p^[i]=c then
                Begin
                     j:=i;
                     While (j<Size) and (p^[j]=Id[j-i+1]) do
                     Begin
                          if j-i+1=Length(Id) then
                          Begin
                               Seek(f,Total+j+1-1); { -1 car le seek commence  zro }
                               if Action=Lire
                                  then {BlockRead(f,d,Len)}
                                       Begin Li:=LongInt(Total)+i-1; Move(Li,d,4); End
                                  else BlockWrite(f,d,Len);
                               Patch:=0; Goto Bye;
                          End;
                          Inc(j);
                     End;
                End;
          Until (i=Size);
     End;
     Patch:=2;
Bye: FreeMem(p,TBuf);
     Close(f);
End;


End.


Un exemple d'utilisation :
--------------------------

Const Ident     : String[5] = 'IdEnT';
      Config    : String = 'Salut . . ';
      ConfigEnd : Byte = $FF;
Const Erreurs   : Array[0..2] of String[30]
                = ('Chane trouve','Fichier non trouv','Chane non trouve');
Begin
     if ParamCount>0 then Config:=ParamStr(1);
     WriteLn(Erreurs[Patch('PATCHER.EXE',Ident,Ecrire,Config,Ofs(ConfigEnd)-Ofs(Config))]);
     WriteLn(Config);
End.

