Program MiniMoon;

Uses Dos,Crt,CommPkg,BufCvt2,TpCrc,Patcher;

Const VitMoy       = 880;
Const Ident        : String[7] = 'Config:';
      Com          : Byte      = 3;
      BitsData     : Byte      = 7;
      Parite       : Char      = 'E';
      Vitesse      : Word      = 1200;
      Reconst      : Byte      = 2; {sre}
      ERapide      : Boolean   = True; {mission MD3 rapide}
      CfgE         : Byte      = $FF;
      NomProg      : String[8] = 'MiniMoon';

      NomProto     : String[2] = 'MD';
      VerProto7    : Char      = '3';
      VerProto8    : Char      = '4';

      Envoi        : String[2] = ^S'A';
      Retour       : String[2] = ^S'B';
      Repetition   : String[2] = ^S'C';
      Guide        : String[2] = ^S'D';
      Annulation   : String[2] = ^S'E';
      Sommaire     : String[2] = ^S'F';
      Correction   : String[2] = ^S'G';
      Suite        : String[2] = ^S'H';

      T_Env = $41; T_Ret = $42; T_Rep = $43; T_Gui = $44;
      T_Ann = $45; T_Som = $46; T_Cor = $47; T_Sui = $48;

Const TaillePack   = 128;                     {128  Nb Oct-7b  / Paquet }
      TailleP8_1   = TaillePack*3 div 4;      { 96}
      TailleP8_2   = TaillePack*7 div 8;      {112  nb Oct-8b  / Paquet }
      PPB          = 15;                      {     nb Paquets / Bloc   }
      TailleBuf    = 2*PPB*TaillePack+100;    {3940 taille buffer       }

      Oct8PBloc_1  : Word = TailleP8_1*PPB;     {1680 nb Oct-8b / Bloc   }
      Oct8PBloc_2  : Word = TailleP8_2*PPB;     {1680 nb Oct-8b / Bloc   }
Const AttendTelech : String[10] = '';

Type  BufT         = Array[1..TailleBuf] of Byte;
      BufP         = ^BufT;
Type  BufT2        = Array[1..2*TailleBuf] of Byte;
      BufP2        = ^BufT2;

Type CleverBloc    = Record
                           Data  : BufP2;
                           BlocS : Word; {Taille du bloc}
                           BlocN : Word; {Numro du bloc}
                           vXor  : Byte; {valeur du Xor}
                     End;
Type  ErrCode      = (Ok,Break,TimeOut,Indefini,Hanged,Fatal);

Var  State          : Word;
     Reception      : Boolean;
     Fini           : Boolean;
     ErrVal         : Integer;
     TailleFic      : LongInt;
     AttrFic        : Word;
     DateFic        : LongInt;
     BlocEnCours    : Word;  { Bloc en cours de rception }
     NbPaquets      : Byte;  { Paquet en cours            }
     NbOct          : Byte;  { Nb Oct-8b dans dernier pak }
     f              : File;
     Bp             : BufP;
     TailleTotale   : LongInt;
     HeureDebut     : LongInt;
     TailleRecue    : Word;
     Touche         : Byte;
     Retrys         : Byte;
     i              : Byte;
     j              : Word;
     ExCode         : ErrCode;
     Blocs          : Array[1..2] of CleverBloc;
     DernierCorrect : Word;  { N du dernier bloc crit sur disque }
     BadBlocs       : Word;
     CheckSum       : Word;    { ou CRC  partir de MD3 }
     ActBloc        : Byte;    { Blocs[ActBloc]... }
     Vit            : Word;    { vitesse du dbit calcule }
     ASauver        : Word;
     NomFic         : String;
     VerPro         : Char;
     DernFic        : Boolean;
{=== Emission seulement ===}
     NoMore         : Boolean;
     NumBloc,BufS   : Word;
     Buf            : BufP;
     BEC            : Array[1..2] of Record Num:Word; Env,Ack:Boolean; End;
                      {BEC=Blocs En Cours, Num=Numro du bloc, Env=Envoy ou non
                                           Ack=Acquitt ou non}
     Recode0d       : Boolean;


Function CheckFini:Boolean;
Begin
     CheckFini:=False;
     if Keypressed and (ReadKey=#$1B) then
     Begin
          CheckFini:=True; ExCode:=Break;
     End;
End;


Function Score(b:Byte):String;
Var x:String;
Begin
     Str(b,x); if b<10 then x:='0'+x; Score:=x;
End;


Function Temps(l:LongInt):String;
Var s:String;
Begin
     s:='';
     if l>=0 then
     Begin
          l:=l div 1000;
          s:=Score(l div 3600)+':';
          l:=l mod 3600;
          s:=s+Score(l div 60)+':'+Score(l mod 60);
     End;
     Temps:=s;
End;


Function AffVit(w:Word):String;
Var x:String;
Begin
     Str(w div 10:3,x); AffVit:=x+'.'+Chr($30+w mod 10);
End;


Procedure SysActivity(Tps,TailleTot,TailleTrans:LongInt);
Var w:LongInt;
Begin
     Write(^M);
     if State>=10 then
     Begin
          if TailleTrans>TailleTot then TailleTrans:=TailleTot;

          Write('  ',NomFic,'  ',TailleTrans,'/',TailleTot);
          if TailleTot>0 then w:=(100*(TailleTrans)) div TailleTot else w:=0;
          Write('  ',w,'%');
          w:=(LongInt(TailleTot*10) div Vit)*1000;
          if Tps div 1000>0 then Write('  ',Temps(1000*(w div 1000-Tps div 1000)));
          Write('  ',AffVit(Vit),'cps');
     End;
     ClrEol;
End;

Function HorlogeMS:LongInt; {heure en millisecondes depuis minuit}
Var Regs:Registers;
Begin
     With Regs do
     Begin
          AH:=$2C; MsDos(Regs);
          HorlogeMS:=1000*(LongInt(DH)+60*(LongInt(CL)+60*LongInt(CH)))+10*LongInt(DL);
     End;
End;


Function SecTime:LongInt;
Var r:Registers;
    Li:LongInt;
Begin
     With r do
     Begin
          Ah:=$2C; MsDos(r);
          Li:=LongInt(CH)*3600+LongInt(CL)*60+LongInt(DH);
          SecTime:=Li;
     End;
End;


Const Data : Array[0..15] of Char
           = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');


Function HexW(w:Word):String;
Begin
     HexW:=Data[Hi(w) div 16]+Data[Hi(w) mod 16]+Data[Lo(w) div 16]+Data[Lo(w) mod 16];
End;


Function HexB(b:Byte):String;
Begin
     HexB:=Data[b div 16]+Data[b mod 16];
End;


Function SecElapsed(x:LongInt):LongInt;
Var i:LongInt;
Begin
     i:=Sectime-x; if i<0 then SecElapsed:=i+86400 else SecElapsed:=i;
End;


Function Mstr(n:LongInt):String;
Var x:String;
Begin
     Str(n,x); Mstr:=x;
End;


Function OteBs(x:String):String;
{Supprime le \ final si ce n'est pas le rep principal qui est spcifi}
Begin
     if (x<>'\') and (Length(x)>1) and (x[Length(x)]='\') then
     if x[Pred(Length(x))]<>':' then dec(x[0]);
     OteBs:=x;
End;


Function AjouteBs(x:String):String;
{Ajoute un \ final}
Begin
     if x='' then else
     if x[Length(x)]=':' then x:=x+'.\' else
     if x[Length(x)]<>'\' then x:=x+'\';
     AjouteBs:=x;
End;


Function RepDeFichier(NomFic:String):String;
 { renvoie le rpertoire seul correspondant  un fichier }
Var a,b,c:PathStr;
Begin
     FSplit(NomFic,a,b,c); RepDeFichier:=OteBs(a);
End;


Procedure Sys(s:String);
Begin
     Write(^M+s); ClrEol; WriteLn;
End;


Function Sequence(Chn:String; Var S:String; Wait:Byte):ErrCode;
 {Attend (maxi Wait sec) la squence Chn et la place dans S. Les ? sont jokers}
Var Hms,Last,LastDisplay:LongInt;
    i,v:Byte;
    c:Char;
Begin
     s:=''; Hms:=SecTime; Last:=SecTime; LastDisplay:=SecTime;
     Repeat
           v:=0;
           if not Reception then if SecTime<>LastDisplay then
           Begin
                SysActivity(HorlogeMs-HeureDebut,TailleFic,TailleTotale);
                LastDisplay:=SecTime;
           End;
           if PortReady(Com) then
           Begin
                c:=Receive(Com);
                if Length(s)=Length(Chn) then Delete(s,1,1);
                s:=s+c;
                if Length(s)=Length(Chn) then
                Begin
                     v:=0;
                     For i:=1 to Length(s) do
                         if (Chn[i]='?') or (Chn[i]=s[i]) then Inc(v);
                End;
                Last:=SecTime;
           End else Fini:=CheckFini;
     Until ((Reception) and (SecElapsed(Last)>5))
        or (v=Length(Chn)) or Fini
        or ((not Reception) and (SecElapsed(Hms)>Wait));
     if v=Length(Chn) then Sequence:=Ok else
     if Fini          then Sequence:=Break else
                           Sequence:=TimeOut;
End;

Function SequenceV(Chn:String; Var S:String):Boolean;
 {Attend (maxi 30sec) la squence finissant par Chn et la place dans S.}
Var Hms,Last:LongInt;
    i:Byte;
    c:Char;
Begin
     SequenceV:=False; s:=''; i:=1; Hms:=SecTime; Last:=SecTime;
     Repeat
           if PortReady(Com) then
           Begin
                c:=Receive(Com); s:=s+c;
                i:=Length(Chn);
                While (i>0) and (s[Length(s)-(Length(Chn)-i)]=Chn[i]) do Dec(i);
                Last:=SecTime;
           End else Fini:=CheckFini;
     Until (SecElapsed(Last)>5) or (SecElapsed(Hms)>60) or (i=0) or Fini;
     if i=0 then SequenceV:=True;
End;

Function SequenceB(Dest:BufP2; Var Size:Word; Var Touche:Byte):ErrCode;
Const z:Word=0;
 {Attend (maxi Wait sec) le buffer finissant par Chn et le place dans Dest^.}
Var Hms,t,zt:LongInt;
    c:Char;
Begin
     Hms:=SecTime; t:=TailleTotale; Size:=0; zt:=HorlogeMs;
     Repeat
           if PortReady(Com) then
           Begin
                c:=Receive(Com); Inc(Size); Dest^[Size]:=Byte(c);
                Inc(z); if z>=Vitesse div 24 then
                Begin
                     z:=0; SysActivity(HorlogeMs-HeureDebut,TailleFic,t+((Size+1)*7 div 8));
                End;
                zt:=HorlogeMs;
           End else
           Fini:=CheckFini;
     Until (HorlogeMs-zt>5000) or
           Fini or ((Size>1) and (Dest^[Size-1]=$13));
     if Fini then SequenceB:=Break else
     if HorlogeMs-zt>5000 then
        if Size>0 then SequenceB:=Hanged
                  else SequenceB:=TimeOut else
        Begin SequenceB:=Ok; Touche:=Byte(Dest^[Size]); End;
     SysActivity(HorlogeMs-HeureDebut,TailleFic,t+((Size+1)*7 div 8));
End;


Function DonneNomFichier(s:String):String;
Var D: DirStr;
    N: NameStr;
    E: ExtStr;
    f: File;
    Ok:Boolean;
    b: Byte;
Begin
     FSplit(s,D,N,E);
     Assign(f,d+N+E); {$i-} Reset(f,1); {$i+}
     if IoResult<>0 then Begin DonneNomFichier:=s; Exit; End;
     Close(f);
     if Length(n)=8 then Dec(n[0]); Ok:=False;
     Repeat
           b:=0;
           Repeat
                 Inc(b); Str(b,s);
                 s:=d+n+s+e;
                 Assign(f,s); {$i-} Reset(f,1); {$i+}
                 Ok:=IoResult<>0; if not Ok Then Close(f);
           Until Ok or (Length(n+Mstr(b+1))>8);
           if not Ok then Dec(n[0]);
           if n='' then n:='Moon00';
     Until Ok;
     DonneNomFichier:=s;
End;


Procedure CalculeVitesse;
Begin
     if ((HorlogeMs-HeureDebut) div 1000)=0
        then Vit:=VitMoy
        else Vit:=Word((TailleTotale*10) div ((HorlogeMs-HeureDebut) div 1000));
     if Vit=0 then Vit:=VitMoy;
End;


Procedure SendBloc(NumeroDuBloc:Word);
 {envoi d'un bloc avec headers}
Var h,j,CheckSum:Word;
    a,b,Pat:Byte; {Pat=Paquets  transmettre}
    bp:BufP;
    xx:String[2];
    {}
    Min:Word; m,n:Byte;
Begin
    Reset(f,1); Seek(f,Pred(LongInt(NumeroDuBloc))*LongInt(Oct8PBloc_2));
    BlockRead(f,Buf^,Oct8PBloc_2,BufS);
    if (BufS<Oct8PBloc_2) or Eof(f) then NoMore:=True;
    Pat:=((Word(BufS) div TailleP8_2));
    Inc(NbPaquets,Pat);
    a:=Pat or $20;
    b:=Word(BufS) mod TailleP8_2;
    if VerPro>='3' then
    Begin
         CheckSum:=0; For j:=1 to BufS do CheckSum:=UpdCrc(Buf^[j],CheckSum);
         xx:=HexB(MoonXor);
    End else
    Begin
         CheckSum:=$55AA;
         For j:=1 to BufS do CheckSum:=(CheckSum Xor Buf^[j]) + (Buf^[j] shl 8);
         xx:='';
    End;
    New(Bp);
    if VerPro>='4' then
       h:=SupCvt8To8c(@Buf^,@Bp^,BufS,MoonXor) else
       Begin
            if (VerPro='3') and ERapide then
            Begin
                 min:=4000; m:=0;
                 For n:=0 to 127 do
                 Begin
                      h:=SupCvt8To7(@Buf^,@Bp^,BufS,TailleBuf,Recode0d,n);
                      if h<min then Begin Min:=h; m:=n; End;
                 End;
                 xx:=HexB(m);
            End else m:=MoonXor;
            h:=SupCvt8To7(@Buf^,@Bp^,BufS,TailleBuf,Recode0d,m);
       End;
    SendString(Com,^L+HexW(NumeroDuBloc)+Chr(a)+HexB(b)+xx+Envoi);
    For j:=1 to h do Send(Com,Char(Bp^[j]));
    SendString(Com,HexW(CheckSum)+Guide);
    Dispose(Bp);

{    Un exemple d'envoi de message :
     SendString(Com,^L'000000000'+Envoi+'Hello'+Envoi);
}
End;


Function Transmission(DejaDetecte:String; Etat:Byte):Byte;
Var x,St:String;
    Okay:Boolean;
    b:Byte;
    Li:LongInt;
    w,Lu:Word;
    Sr:SearchRec;
    VerProto:Char;
    Fich:File;
Begin
     if BitsData=7 then VerProto:=VerProto7
                   else VerProto:=VerProto8;
     Reception:=Etat=1;
     FillChar(Bec,SizeOf(Bec),0); NumBloc:=0; NomFic:='';
     NbPaquets:=0; Vit:=VitMoy; ExCode:=Indefini;
     NoMore:=False;
     New(Buf);
     State:=0; Fini:=False; BlocEnCours:=0; New(Bp);
     For i:=1 to 2 do With Blocs[i] do Begin New(Data); BlocS:=0; End;
     HeureDebut:=HorlogeMs; TailleTotale:=0; TailleFic:=0; Retrys:=0;
     DernierCorrect:=0; VerPro:=' ';
     if Etat=2 then
     Begin
          x:='MoonDial '+VerProto+'.0'; VerPro:=VerProto;
          NomFic:=DejaDetecte; State:=100;
     End else
     if DejaDetecte<>'' then
     Begin
          if Copy(DejaDetecte,1,2)='MD' then x:='MoonDial' else x:='Inconnu';
          if VerProto<DejaDetecte[3] then VerPro:=VerProto
                                     else VerPro:=DejaDetecte[3];
          SendString(Com,NomProg+VerPro+'.0'+Envoi);
          State:=10; Retrys:=0;
     End;
     AttendTelech:='';
     Repeat
           SysActivity(HorlogeMs-HeureDebut,TailleFic,TailleTotale);
           Fini:=CheckFini; if Fini then SendString(Com,Annulation+Sommaire) else
           Begin
Case State of
     {attend le header de dbut de transmission}
     0: Case Sequence('MD???'+Envoi,x,5) of
             Ok: Begin
                      if VerProto<x[3] then VerPro:=VerProto
                                       else VerPro:=x[3];
                      SendString(Com,NomProg+VerPro+'.0'+Envoi);
                      State:=10; Retrys:=0;
                 End;
        TimeOut: State:=0;
        End;

     {attend le header de dbut de fichier}
    10: Begin
             HeureDebut:=HorlogeMs;
             if SequenceV(Envoi,x) and (Length(x)>=14) then
             Begin
                  if VerPro>='2' then While (x<>'') and (x[1]<>^A) do Delete(x,1,1);
                  Dec(x[0],2); {on enlve Envoi}
                  if VerPro>='3' then
                  Begin
                       Val('$'+Copy(x,Length(x)-7,8),DateFic,ErrVal); Dec(x[0],8);
                  End;
                  Val('$'+Copy(x,Length(x)-7,8),TailleFic,ErrVal);
                  if ErrVal<>0 then
                  Begin
                       Inc(Retrys);
                       if Retrys=4 then
                       Begin
                            Fini:=True; ExCode:=Fatal;
                       End else
                       Begin
                            if VerPro>='3' then SendString(Com,Chr($40+0)+Repetition)
                                           else SendString(Com,Repetition);
                       End;
                  End else
                  Begin
                       if TailleFic>DiskFree(0) then
                       Begin
                            Sys('Espace disque insuffisant');
                            if VerPro>='3' then SendString(Com,Chr($40+0)+Annulation)
                                           else SendString(Com,Annulation);
                            Fini:=True; ExCode:=Fatal;
                       End else
                       Begin
                            Dec(x[0],8); {on enlve la taille}
                            if VerPro>='3' then
                            Begin
                                 DernFic:=Odd(Byte(x[Length(x)])); Dec(x[0]);
                            End else DernFic:=True;
                            AttrFic:=Byte(x[Length(x)])-$40;
                            Dec(x[0],2); {on enlve l'attribut et le 04h}
                            Delete(x,1,1); {on enlve le 01h}
                            State:=20; TailleTotale:=0; ActBloc:=1;
                            For i:=1 to 2 do Blocs[i].BlocS:=0;
                            BadBlocs:=0; DernierCorrect:=0; Vit:=VitMoy;
                            i:=Length(x);
                            While (i<>0) and (x[i]<>'\') do Dec(i);
                            if i<>0 then x:=Copy(x,i+1,Length(x)-i);
                            Assign(f,x); {$i-} Reset(f,1); {$i+}
                            if IoResult<>0 then b:=0 else
                            Begin
                                 if VerPro>='3' then
                                 Case Reconst of
                                      0: b:=0;
                                      1: Begin
                                              Li:=FileSize(f); Close(f);
                                              if Li>=Oct8PBloc_2 then b:=1 else
                                              Begin
                                                   b:=0; Erase(f);
                                              End;
                                         End;
                                      2: Begin
                                              Li:=FileSize(f); Close(f);
                                              if Li>=Oct8PBloc_2 then b:=2 else
                                              Begin
                                                   b:=0; Erase(f);
                                              End;
                                         End;
                                 End else
                                 Begin
                                      b:=0; Close(f);
                                 End;
                            End;
                            Case b of
                                 0: Begin
                                         if VerPro>='3' then SendString(Com,Chr($40+0)+Suite)
                                                        else SendString(Com,Suite);
                                         x:=DonneNomFichier(x);
                                         Assign(f,x); {$i-} Rewrite(f,1); {$i+}
                                         ErrVal:=IoResult;
                                         if ErrVal<>0 then
                                         Begin
                                              Sys('Problme disque. '+Mstr(ErrVal));
                                              Fini:=True; ExCode:=Fatal;
                                         End;
                                    End;
                                 1: Begin
                                         SendString(Com,Chr($40+0)+Guide);
                                         Reset(f,1); Li:=FileSize(f);
                                         Seek(f,Oct8PBloc_2*(Li div Oct8PBloc_2));
                                         Truncate(f);
                                         DernierCorrect:=Li div Oct8PBloc_2;
                                         TailleTotale:=LongInt(DernierCorrect)*Oct8PBloc_2;
                                         {envoi de la RRS}
                                         SendString(Com,HexW(DernierCorrect)+Guide);
                                         Sys('Reconstruction rapide.');
                                    End;
                                 2: Begin
                                         SendString(Com,Chr($40+1)+Guide);
                                         Sys('Reconstruction fiable');
                                         Reset(f,1); DernierCorrect:=0;
                                         TailleTotale:=0;
                                         State:=40;
                                    End;
                            End;
                            NomFic:=x;
                            Str(TailleFic,St);
                            {
                            Sys(Mstr((TailleFic+Oct8PBloc_2-1) div Oct8PBloc_2)+' bloc(s)  recevoir');
                            }
                       End;
                  End;
             End else
             Begin
                  Fini:=True; ExCode:=TimeOut;
             End;
        End;

     {Reoit le header de bloc}
    20: Begin
             Case VerPro of
                  '1': ExCode:=Sequence(^L+'??????'+Envoi,x,15);
                  '2': ExCode:=Sequence(^L+'???????'+Envoi,x,15);
                  else ExCode:=Sequence(^L+'?????????'+Envoi,x,15);
             End;
             Case ExCode of
                  Ok: Begin
                           Val('$'+Copy(x,2,4),BlocEnCours,ErrVal);
                           if ErrVal<>0 then
                           Begin
                                {Sys('Header de dbut de bloc incorrect '+x);}
                           End else
                           if BlocEnCours=0 then State:=50 else
                           Begin
                                Blocs[ActBloc].BlocN:=BlocEnCours; Okay:=False;
                                Blocs[ActBloc].vXor:=MoonXor;
                                if VerPro='1' then
                                Begin
                                     NbOct:=Byte(x[7]) and $5F;
                                     if NbOct and $40=$40 then NbOct:=NbOct or $20;
                                     NbOct:=NbOct and $3F;
                                     NbPaquets:=Byte(x[6]) and $5F;
                                     if NbPaquets and $40=$40 then
                                        Inc(NbOct,TailleP8_1 div 2);
                                     NbPaquets:=(NbPaquets and $1F); Okay:=True;
                                End else
                                Begin
                                     Val('$'+Copy(x,7,2),NbOct,ErrVal);
                                     if ErrVal<>0 then
                                     Begin
                                          {Sys('Header de dbut de bloc incorrect. '+x);}
                                     End else
                                     Begin
                                          if VerPro>='3' then
                                          Begin
                                               Val('$'+Copy(x,9,2),b,ErrVal);
                                               if ErrVal<>0 then
                                               Begin
                                                    {Sys('Header de dbut de bloc incorrect. '+x);}
                                               End else
                                               Begin
                                                    Okay:=True; Blocs[ActBloc].vXor:=b;
                                               End;
                                          End else Okay:=True;
                                     End;
                                End;
                                if Okay then
                                Begin
                                     NbPaquets:=Byte(x[6]) and $1F;
                                     Retrys:=0; State:=30;
                                End;
                           End;
                      End;
                  TimeOut: if Retrys>=3 then
                           Begin
                                Fini:=True;
                           End else
                           Begin
                                Inc(Retrys); Inc(BadBlocs);
                                Sys('Liaison dfectueuse 1');
                                SendString(Com,HexW(DernierCorrect)+Retour);
                                For i:=1 to 2 do With Blocs[i] do
                                Begin
                                     BlocS:=0; BlocN:=0;
                                End;
                           End;
             End;
        End;

        {reoit les donnes du bloc}
    30: Begin
             ExCode:=SequenceB(Blocs[ActBloc].Data,TailleRecue,Touche);
             Case ExCode of
                  Ok: Begin
                           Retrys:=0;
                           x[0]:=#4; Move(Blocs[ActBloc].Data^[TailleRecue-5],x[1],4);
                           Case VerPro of
                                '1': Begin
                                          {attention: Cvt6To8 padde le buffer source avec des 0 !!!}
                                          Cvt6To8(@Blocs[ActBloc].Data^,@Bp^,TailleRecue-5);
                                          ASauver:=NbPaquets*TailleP8_1+NbOct;
                                          {Word(NbPaquets)*TaillePack+(Word(NbOct)*4+2) div 3);}
                                     End;
                            '2','3': ASauver:=SupCvt7To8(@Blocs[ActBloc].Data^,@Bp^,TailleRecue-6,Blocs[ActBloc].vXor);
                                else ASauver:=SupCvt8To8d(@Blocs[ActBloc].Data^,@Bp^,TailleRecue-6,Blocs[ActBloc].vXor);
                           End;
                           if VerPro>='3' then
                           Begin
                                CheckSum:=0;
                                For j:=1 to ASauver do
                                Begin
                                    CheckSum:=UpdCrc(Bp^[j],CheckSum);
                                End;
                           End else
                           Begin
                                CheckSum:=$55AA;
                                For j:=1 to ASauver do
                                    CheckSum:=(CheckSum Xor Bp^[j]) + (Bp^[j] shl 8);
                           End;
                           if HexW(CheckSum)=x then
                           Begin
                                SendString(Com,HexW(BlocEnCours)+Suite);
                                State:=20;
                                if VerPro='1' then Blocs[ActBloc].BlocS:=TailleRecue-5
                                              else Blocs[ActBloc].BlocS:=TailleRecue-6;
                                if BlocEnCours=Succ(DernierCorrect) then
                                Begin
                                     Inc(DernierCorrect);
                                     Inc(TailleTotale,ASauver);
                                     CalculeVitesse;
                                     BlockWrite(f,Bp^,ASauver);
                                     if ActBloc=1 then i:=2 else i:=1;
                                     if Blocs[i].BlocS<>0 then
                                     Begin
                                          if Blocs[i].BlocN=Succ(DernierCorrect) then
                                          Begin
                                               Inc(DernierCorrect);
                                               if VerPro='1' then
                                               Begin
                                                    Cvt6To8(@Blocs[i].Data^,@Bp^,Blocs[i].BlocS);
                                                    ASauver:=Blocs[i].BlocS*3 div 4;
                                               End else ASauver:=SupCvt7To8(@Blocs[i].Data^,@Bp^,
                                                                            Blocs[i].BlocS,Blocs[i].vXor);
                                               Inc(TailleTotale,ASauver);
                                               CalculeVitesse;
                                               BlockWrite(f,Bp^,ASauver);
                                               Blocs[i].BlocS:=0;
                                          End else
                                          Begin
                                               Fini:=true; ExCode:=Fatal;
                                          End;
                                     End;
                                     if TailleTotale>=TailleFic then
                                     Begin
                                          SysActivity(HorlogeMs-HeureDebut,TailleFic,TailleFic);
                                          WriteLn;
                                          if DernFic then Fini:=True else
                                          Begin
                                               Str(TailleFic:8,St);
                                               NomFic:=''; State:=10;
                                          End;
                                     End;
                                End else
                                if BlocEnCours>=DernierCorrect then
                                Begin
                                     if ActBloc=1 then ActBloc:=2 else ActBloc:=1;
                                     if Blocs[ActBloc].BlocS<>0 then
                                     Begin
                                          {aucun bloc vide donc erreur de
                                           rception:on calcule le bloc 
                                           librer et on redemande celui qui
                                           manque}
                                          {calcul du bloc  librer}
                                          if Blocs[1].BlocN>Blocs[2].BlocN then
                                             ActBloc:=1 else ActBloc:=2;
                                          SendString(Com,HexW(Succ(DernierCorrect))+Annulation);
                                     End;
                                End;
                                Blocs[ActBloc].BlocS:=0;
                           End else
                           Begin
                                Inc(BadBlocs);
                                SendString(Com,HexW(BlocEnCours)+Annulation);
                                Blocs[ActBloc].BlocS:=0;
                                State:=20;
                           End;
                      End;
                  Hanged,
                  TimeOut: if (TailleRecue=0) or (Blocs[ActBloc].Data^[1]<>$0c) then
                           Begin
                                Inc(Retrys);
                                if Retrys>3 then
                                Begin
                                     Sys('Transfert interrompu, trop d''erreurs');
                                     Fini:=True;
                                End else
                                Begin
                                     Sys('Liaison dfectueuse 2');
                                     Inc(BadBlocs);
                                     SendString(Com,HexW(DernierCorrect)+Retour);
                                     For i:=1 to 2 do With Blocs[i] do
                                     Begin
                                          BlocS:=0; BlocN:=0;
                                     End;
                                     State:=20;
                                End;
                           End else
                           Begin
                                Inc(BadBlocs);
                                SendString(Com,HexW(BlocEnCours)+Annulation);
                                Blocs[ActBloc].BlocS:=0;
                                State:=20;
                           End;
             End;
        End;

        { Reconstruction dynamique - attente de RRD1 }
    40: Begin
             ExCode:=Sequence('????????'+Envoi,x,15);
             if ExCode=Ok then
             Begin
                  Val('$'+Copy(x,1,4),BlocEnCours,ErrVal);
                  if ErrVal<>0 then
                  Begin
                       SendString(Com,Repetition);
                  End else
                  if BlocEnCours=0 then
                  Begin
                       Sys('Fichier parfaitement intgre');
                       ExCode:=Ok; Fini:=True;
                  End else
                  Begin
                       Val('$'+Copy(x,5,4),w,ErrVal);
                       if ErrVal<>0 then
                       Begin
                            SendString(Com,Repetition);
                       End else
                       Begin
                            Seek(f,LongInt(Oct8PBloc_2)*(BlocEnCours-1));
                            BlockRead(f,Bp^,Oct8PBloc_2,Lu);
                            Okay:=True;
                            if Lu=0 then Okay:=False else
                            Begin
                                 CheckSum:=0;
                                 For j:=1 to Lu do
                                     CheckSum:=UpdCrc(Bp^[j],CheckSum);
                                 if CheckSum<>w then Okay:=False;
                            End;
                            if Okay then
                            Begin
                                 SendString(Com,Suite);
                                 if BlocEnCours>DernierCorrect
                                    then Inc(DernierCorrect);
                                 Inc(TailleTotale,LongInt(Oct8PBloc_2));
                            End else
                            Begin
                                 SendString(Com,Guide);
                                 State:=20; Seek(f,LongInt(DernierCorrect)*Oct8PBloc_2);
                                 Truncate(f);
                                 Sys('Reprise au bloc '+Mstr(DernierCorrect+1));
                            End;
                       End;
                  End;
             End;
        End;

        {message}
    50: Begin
             ExCode:=SequenceB(Blocs[ActBloc].Data,TailleRecue,Touche);
             Sys('Message');
             For w:=1 to TailleRecue-2 do Write(Chr(Blocs[ActBloc].Data^[w]));
             WriteLn;
             State:=20;
        End;

{===================== E M I S S I O N ======================}

   100: Begin
             FindFirst(NomFic,AnyFile,Sr);
             if DosError<>0 then
             Begin
                  Sys(NomFic+' introuvable.'); Fini:=True; ExCode:=Fatal;
             End else
             Begin
                  While (DosError=0) and (Sr.Attr and Directory<>0) do FindNext(Sr);
                  if DosError=0 then
                  Begin
                       NomFic:=AjouteBs(RepDeFichier(NomFic))+Sr.Name;
                       Assign(f,NomFic); {$i-} Reset(f,1); {$i+}
                       if IoResult<>0 then
                       Begin
                            Sys(NomFic+' introuvable.'); Fini:=True; ExCode:=Fatal;
                       End else
                       Begin
                            TailleFic:=FileSize(f); GetFTime(f,DateFic); Close(f);
                            GetFAttr(f,AttrFic);
                            if TailleFic=0 then
                            Begin
                                 Sys('Fichier de taille nulle.'); Fini:=True; ExCode:=Fatal;
                            End else State:=110;
                       End;
                       Retrys:=5;
                  End else
                  Begin
                       Sys('Aucun fichier '+NomFic+' trouv.'); Fini:=True; ExCode:=Fatal;
                  End;
             End;
        End;

        {envoi du header dbut trans}
   110: Begin
             SendString(Com,#27'%'+NomProto+VerProto+'.0'+Envoi); State:=120;
        End;

          {attente rponse}
     120: Begin
               ExCode:=Sequence('???????????'+Envoi,x,4);
               Case ExCode of
                    Ok: Begin
                             Dec(x[0],2);
                             State:=128; Retrys:=3;
                             if VerProto<x[9] then VerPro:=VerProto
                                              else VerPro:=x[9];
                         End;
                    TimeOut: Begin
                                  State:=110; Dec(Retrys);
                                  if Retrys=0 then
                                  Begin Fini:=True; Sys('Pas de rcepteur.'); End;
                             End;
               End;
         End;

         {FindNext pour savoir si le fichier est le dernier}
    128: Begin
              Repeat
                    FindNext(Sr);
              Until (Sr.Attr and Directory=0) or (DosError<>0);
              DernFic:=DosError<>0; State:=130;
         End;

         {envoi header de fichier}
    130: Begin                                          {\/dernier fichier}
              St:=^A+NomFic+^D + Char(Lo(AttrFic)+$40) + Chr($40+Ord(DernFic))+
                  HexW(TailleFic shr 16)+HexW(TailleFic and $FFFF);
              if VerPro>='3' then St:=St+HexW(DateFic shr 16)+HexW(DateFic and $FFFF);
              St:=St+Envoi;
              SendString(Com,St);
              NoMore:=False; NumBloc:=0;
              FillChar(BEC,SizeOf(BEC),0);
              State:=140;
         End;

        {attente acquittement fichier}
    140: Begin
              if VerPro>='3' then ExCode:=Sequence('?'^S'?',x,10)
                             else ExCode:=Sequence(^S'?',x,10);
              Case ExCode of
                   Ok: Begin
                            if x[Length(x)]=Char(T_Sui) then
                            Begin
                                 Recode0d:=(VerPro>='3') and (Byte(x[1]) and $2=$2);
                                 HeureDebut:=HorlogeMs;
                                 NbPaquets:=0; BadBlocs:=0;
                                 DernierCorrect:=0;
                                 TailleTotale:=0;
                                 Retrys:=9;
                                 State:=150;
                                 Str((TailleFic+Oct8PBloc_2-1) div Oct8PBloc_2,St);
                                 Str(TailleFic,St);
                            End else
                            if x[Length(x)]=Char(T_Rep) then
                            Begin
                                 State:=130; Dec(Retrys);
                                 if Retrys=0 then Begin State:=110; Retrys:=5; End;
                            End else
                            if x[Length(x)]=Char(T_Ann) then
                            Begin
                                 Sys('Fichier refus');
                                 Fini:=True; ExCode:=Fatal;
                            End else
                            if x[Length(x)]=Char(T_Gui) then
                            Begin
                                 Recode0d:=Byte(x[1]) and $2=$2;
                                 HeureDebut:=HorlogeMs; BadBlocs:=0;
                                 Retrys:=9;
                                 if Byte(x[1]) and $1=$1
                                    then State:=180  {RD}
                                    else State:=170; {RS}
                            End;
                       End;
                   TimeOut: Begin
                                 State:=130; Dec(Retrys);
                                 if Retrys=0 then Begin State:=110; Retrys:=5; End;
                            End;
              End;
         End;

        {envoi du header de dbut de bloc et du bloc}
    150: Begin
              State:=160; Okay:=True;
              For i:=1 to 2 do With BEC[i] do if Okay then
              if Num=0 then
              Begin
                   if NumBloc-DernierCorrect<=1 then
                   Begin
                        if not NoMore then
                        Begin
                             Inc(NumBloc); Num:=NumBloc; State:=150; Okay:=False;
                        End;
                   End;
              End else
              if not Env then
              Begin
                   Str(Num:5,St);
                   SendBloc(Num); Env:=True; State:=150; Retrys:=9;
              End;
         End;

        {attente acquittement de bloc}
    160: Begin
              ExCode:=Sequence('????'^S'?',x,20);
              Case ExCode of
                   Ok: Begin
                            Val('$'+Copy(X,1,4),BufS,ErrVal);
                            if ErrVal<>0 then
                            Begin
                                 Sys('N de bloc incomprhensible: '+x);
                            End else
                            Begin
                                 if x[6]=Retour[2] then
                                 Begin
                                      Sys('Reprise aprs erreur');
                                      DernierCorrect:=BufS; State:=150;
                                      FillChar(Bec,SizeOf(Bec),0); NumBloc:=BufS; Inc(BadBlocs);
                                      XFlush(Com);
                                 End else
                                 For i:=1 to 2 do With BEC[i] do if Num=BufS then
                                 if x[6]=Suite[2] then
                                 Begin
                                      Ack:=True;
                                      Str(BufS:5,St);
                                      if BufS=Succ(DernierCorrect) then
                                      Begin
                                           Inc(DernierCorrect);
                                           Num:=0; Env:=false; Ack:=False;
                                      End;
                                      if i=1 then j:=2 else j:=1;
                                      if (Bec[j].Num<>0) and Bec[j].Env and Bec[j].Ack then
                                      Begin
                                           Inc(DernierCorrect); FillChar(Bec[j],SizeOf(Bec[j]),0);
                                      End;
                                      TailleTotale:=LongInt(Oct8PBloc_2)*DernierCorrect;
                                      CalculeVitesse;
                                      j:=TailleFic div Oct8PBloc_2;
                                      if TailleFic mod Oct8PBloc_2<>0 then Inc(j);
                                      Fini:=Fini or (j=DernierCorrect);
                                      if Fini then
                                      Begin
                                           SysActivity(HorlogeMs-HeureDebut,TailleFic,TailleFic);
                                           WriteLn;
                                           if not DernFic then
                                           Begin
                                                Fini:=False;
                                                Str(TailleFic:8,St);
                                                NomFic:=AjouteBs(RepDeFichier(NomFic))+Sr.Name;
                                                {$i-} Close(f); {$i+} if IoResult<>0 then {dj ferm};
                                                Assign(f,NomFic); {$i-} Reset(f,1); {$i+}
                                                if IoResult<>0 then
                                                Begin
                                                     Sys(NomFic+' introuvable.'); Fini:=True; ExCode:=Fatal;
                                                End else
                                                Begin
                                                     TailleFic:=FileSize(f); GetFTime(f,DateFic); Close(f);
                                                     GetFAttr(f,AttrFic);
                                                     if TailleFic=0 then
                                                     Begin
                                                          Sys('Fichier de taille nulle.'); Fini:=True; ExCode:=Fatal;
                                                     End else State:=128;
                                                End;
                                                Retrys:=5;
                                           End;
                                      End;
                                      if not NoMore then State:=150;
                                 End else
                                 {Si Annulation...}
                                 Begin
                                      Str(BufS:5,St);
                                      Env:=False; State:=150; Inc(BadBlocs);
                                 End;
                                 TailleTotale:=LongInt(Oct8PBloc_2)*DernierCorrect;
                                 CalculeVitesse;
                            End;
                       End;
                   TimeOut: Begin
                                 Dec(Retrys); if Retrys=0 then Fini:=True;
                            End;
              End;
         End;

         {Attente de la RRS}
    170: Begin
              ExCode:=Sequence('????'^S'D',x,20);
              Case ExCode of
                   Ok: Begin
                            Val('$'+Copy(X,1,4),BufS,ErrVal);
                            if ErrVal<>0 then
                            Begin
                                 Sys('RRS incomprhensible: '+x); Fini:=True;
                            End else
                            Begin
                                 Sys('Reconst rapide bloc '+Mstr(BufS));
                                 DernierCorrect:=BufS; State:=150; Retrys:=5;
                                 TailleTotale:=LongInt(BufS)*Oct8PBloc_2;
                                 FillChar(Bec,SizeOf(Bec),0); NumBloc:=BufS;
                                 XFlush(Com);
                            End;
                       End;
                   TimeOut: Begin
                                 Sys('RRS non reue.'); Fini:=True;
                            End;
              End;
         End;

         { Reconstruction dynamique - Initialisations}
    180: Begin
              Sys('Reconstruction rapide');
              State:=185; DernierCorrect:=0; TailleTotale:=0; Retrys:=5;
              FillChar(Bec,SizeOf(Bec),0); NumBloc:=0; XFlush(Com);
         End;

         { Envoi de la RRD }
    185: if LongInt(DernierCorrect)*Oct8PBloc_2>=TailleFic then
         Begin
              Sys('Fichier parfaitement intgre.');
              SendString(Com,'00000000'+Envoi); XSynchro(Com); Delay(100);
              ExCode:=Ok; Fini:=True;
         End else
         Begin
              Reset(f,1); Seek(f,LongInt(DernierCorrect)*Oct8PBloc_2);
              BlockRead(f,Buf^,Oct8PBloc_2,Lu);
              CheckSum:=0; For j:=1 to Lu do CheckSum:=UpdCrc(Buf^[j],CheckSum);
              SendString(Com,HexW(DernierCorrect+1)+HexW(CheckSum)+Envoi);
              State:=190;
         End;

         { Attente de l'ARD }
    190: Begin
              ExCode:=Sequence(^S'?',x,5);
              Case ExCode of
                        Ok: Begin
                                 Case Byte(x[2]) of
                                      T_Rep: State:=185;
                                      T_Sui: Begin
                                                  Inc(DernierCorrect);
                                                  Inc(TailleTotale,Oct8PBloc_2);
                                                  State:=185;
                                             End;
                                      T_Gui: Begin
                                                  State:=150; Retrys:=5;
                                                  FillChar(Bec,SizeOf(Bec),0);
                                                  NumBloc:=DernierCorrect;
                                                  XFlush(Com);
                                             End;
                                 End;
                            End;
                   TimeOut: Begin
                                 Dec(Retrys);
                                 if Retrys=0 then Fini:=True else State:=185;
                            End;
              End;
         End;

End; {Case}
           End;
     Until Fini;

     { !!! Ne pas dissocier les deux lignes suivantes !!! }
     {$i-} Close(f); {$i+} if IoResult=0 then {Dj ferm};
     SetFTime(f,DateFic);

     XFlush(Com); b:=1;
     Case ExCode of
          Ok : Begin
                    St:='Transfert '; b:=0;
                    if BadBlocs=0 then St:=St+'parfait' else
                    if BadBlocs<5 then St:=St+'correct' else
                    if BadBlocs<10 then St:=St+'dlicat' else
                    if BadBlocs<20 then St:=St+'difficile' else
                                        St:=St+'miraculeux, brlez un cierge';
               End;
           Break: Begin b:=2; St:='Interruption utilisateur'; End;
          TimeOut,
          Hanged: Begin b:=3; St:='Liaison rompue'; End;
           Fatal: Begin b:=4; St:='Erreur fatale.'; End;
             else St:='';
     End;
     Sys('Tlchargement termin. '+St);
     Dispose(Bp); For i:=1 to 2 do Dispose(Blocs[i].Data);
     Transmission:=b;
End;


Procedure ActualParams;
Begin
     Write('Actuellement: COM',Com,': ',Vitesse,',',Parite,',',BitsData,',1    ');
     Case Reconst of
          0: Write('Pas de reconstruction, ');
          1: Write('Reconstruction rapide, ');
          2: Write('Reconstruction fiable, ');
     End;
     if ERapide then Write('mission rapide.') else Write('mission lente.');
     WriteLn;
End;


Procedure Help;
Begin
     WriteLn('Usage: MiniMoon [-Paramtre] [/Paramtre] [NomFic*.*]');
     WriteLn;
     WriteLn('       NomFic*.* signifie que l''on va mettre le(s) fichier(s)');
     WriteLn('       dcrit(s) par le masque NomFic*.*');
     WriteLn;
     WriteLn('       Les paramtres peuvent commencer par - ou /');
     WriteLn;
     WriteLn('       -Cn = port n              1n4');
     WriteLn('       -Bn = vitesse n           300n19200');
     WriteLn('       -Px = parit x            x=E (paire), x=O (impaire), x=N (sans)');
     WriteLn('       -Dn = n bits de donnes   7n8');
     WriteLn('       -Rx = reconstruction x    x=R (rapide), x=F (fiable), x=N (sans)');
     WriteLn('       -Ex = emission x          x=R (rapide), x=L (lente)');
     WriteLn('       -S  = sauvegarder config.');
     WriteLn;
     ActualParams;
     Halt(5);
End;


Procedure AnalysePrm;
Var Op:Byte;      {opration: 1=rception, 2=mission}
    s:String;
    Masque:String;
    i:Byte;
    Err:Integer;
    Speed:Word;
    Sauver:Boolean;
Begin
     Op:=1; Masque:=''; Sauver:=False;
     if ParamCount>0 then
     Begin
          if ParamStr(1)='?' then Help else
          For i:=1 to ParamCount do
          Begin
               s:=ParamStr(i);
               if (s[1]='-') or (s[1]='/') then
               Begin
                    Delete(s,1,1);
                    Case UpCase(s[1]) of
                         '?': Help;
                         'B': Begin
                                   Delete(s,1,1);
                                   Val(s,Speed,Err); if Err<>0 then Speed:=0;
                                   if (Speed<300) or (Speed>19200)
                                      then WriteLn('Paramtre -B incorrect')
                                      else Vitesse:=Speed;
                              End;
                         'C': Begin
                                   Delete(s,1,1);
                                   if (s='') or (s[1]>'4') or (s[1]<'1')
                                      then WriteLn('Paramtre -C incorrect')
                                      else Com:=Ord(s[1])-$30;
                              End;
                         'D': Begin
                                   Delete(s,1,1);
                                   if (s='') or (s[1]>'8') or (s[1]<'7')
                                      then WriteLn('Paramtre -D incorrect')
                                      else BitsData:=Ord(s[1])-$30;
                              End;
                         'E': Begin
                                   Delete(s,1,1); s[1]:=UpCase(s[1]);
                                   if (s='') or ((s[1]<>'R') and (s[1]<>'L'))
                                      then WriteLn('Paramtre -E incorrect')
                                      else Case s[1] of
                                                'N': ERapide:=False;
                                                'R': ERapide:=True;
                                           End;
                              End;
                         'P': Begin
                                   Delete(s,1,1); s[1]:=UpCase(s[1]);
                                   if (s='') or ((s[1]<>'E') and (s[1]<>'O') and (s[1]<>'N'))
                                      then WriteLn('Paramtre -P incorrect')
                                      else Parite:=s[1];
                              End;
                         'R': Begin
                                   Delete(s,1,1); s[1]:=UpCase(s[1]);
                                   if (s='') or ((s[1]<>'R') and (s[1]<>'F') and (s[1]<>'N'))
                                      then WriteLn('Paramtre -R incorrect')
                                      else Case s[1] of
                                                'N': Reconst:=0;
                                                'R': Reconst:=1;
                                                'F': Reconst:=2;
                                           End;
                              End;
                         'S': Sauver:=True;
                    End;
               End else
               Begin
                    {c'est un nom de fichier donc mission}
                    Masque:=s; Op:=2;
               End;
          End;
     End;
     ActualParams;
     if Sauver then
     Begin
          i:=Patch(ParamStr(0),Ident,Ecrire,Com,Ofs(CfgE)-Ofs(Com));
          Case i of
               0: WriteLn('Configuration sauvegarde');
               1: WriteLn('Fichier '+ParamStr(0)+' introuvable');
               2: WriteLn('Identificateur non trouv. Fichier compact ?');
          End;
	  Halt(5);
     End;
     OpenCom(Com,Vitesse,Parite,BitsData,1,8192,8192);
     i:=Transmission(Masque,Op);
     CloseCom(Com);
     Halt(i);
End;


Begin
     WriteLn('MiniMoon   1.2   Jc Boggio   17-Mai-92   DomPub'); WriteLn;
     AnalysePrm;
End.

